[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]
[PATCH v6 31/36] multi-process/mon: choose HMP commands based on target
From: |
elena . ufimtseva |
Subject: |
[PATCH v6 31/36] multi-process/mon: choose HMP commands based on target |
Date: |
Mon, 6 Apr 2020 02:41:21 -0700 |
From: Elena Ufimtseva <address@hidden>
Add "targets" field to HMP command definition to select the targets
which would be supported by each command
Signed-off-by: Elena Ufimtseva <address@hidden>
Signed-off-by: John G Johnson <address@hidden>
Signed-off-by: Jagannathan Raman <address@hidden>
---
hmp-commands-info.hx | 10 ++++++++++
hmp-commands.hx | 20 ++++++++++++++++++++
scripts/hxtool | 35 ++++++++++++++++++++++++++++++++++-
3 files changed, 64 insertions(+), 1 deletion(-)
mode change 100644 => 100755 scripts/hxtool
diff --git a/hmp-commands-info.hx b/hmp-commands-info.hx
index ca5198438d..1fbca7a18d 100644
--- a/hmp-commands-info.hx
+++ b/hmp-commands-info.hx
@@ -23,6 +23,7 @@ ERST
.params = "",
.help = "show the version of QEMU",
.cmd = hmp_info_version,
+ .targets = "scsi",
.flags = "p",
},
@@ -50,6 +51,7 @@ ERST
.params = "",
.help = "show the character devices",
.cmd = hmp_info_chardev,
+ .targets = "scsi",
.flags = "p",
},
@@ -65,6 +67,7 @@ ERST
.help = "show info of one block device or all block devices "
"(-n: show named nodes; -v: show details)",
.cmd = hmp_info_block,
+ .targets = "scsi",
},
SRST
@@ -78,6 +81,7 @@ ERST
.params = "",
.help = "show block device statistics",
.cmd = hmp_info_blockstats,
+ .targets = "scsi",
},
SRST
@@ -91,6 +95,7 @@ ERST
.params = "",
.help = "show progress of ongoing block device operations",
.cmd = hmp_info_block_jobs,
+ .targets = "scsi",
},
SRST
@@ -161,6 +166,7 @@ ERST
.params = "",
.help = "show the command line history",
.cmd = hmp_info_history,
+ .targets = "scsi",
.flags = "p",
},
@@ -214,6 +220,7 @@ ERST
.params = "",
.help = "show PCI info",
.cmd = hmp_info_pci,
+ .targets = "scsi",
},
SRST
@@ -598,6 +605,7 @@ ERST
.params = "",
.help = "show device tree",
.cmd = hmp_info_qtree,
+ .targets = "scsi",
},
SRST
@@ -611,6 +619,7 @@ ERST
.params = "",
.help = "show qdev device model list",
.cmd = hmp_info_qdm,
+ .targets = "scsi",
},
SRST
@@ -624,6 +633,7 @@ ERST
.params = "[path]",
.help = "show QOM composition tree",
.cmd = hmp_info_qom_tree,
+ .targets = "scsi",
.flags = "p",
},
diff --git a/hmp-commands.hx b/hmp-commands.hx
index 02cae25c24..1b60676d7c 100644
--- a/hmp-commands.hx
+++ b/hmp-commands.hx
@@ -45,6 +45,7 @@ ERST
.params = "",
.help = "quit the emulator",
.cmd = hmp_quit,
+ .targets = "scsi",
},
SRST
@@ -76,6 +77,7 @@ ERST
.params = "device size",
.help = "resize a block image",
.cmd = hmp_block_resize,
+ .targets = "scsi",
},
SRST
@@ -92,6 +94,7 @@ ERST
.params = "device [speed [base]]",
.help = "copy data from a backing file into a block device",
.cmd = hmp_block_stream,
+ .targets = "scsi",
},
SRST
@@ -105,6 +108,7 @@ ERST
.params = "device speed",
.help = "set maximum speed for a background block operation",
.cmd = hmp_block_job_set_speed,
+ .targets = "scsi",
},
SRST
@@ -120,6 +124,7 @@ ERST
"\n\t\t\t if you want to abort the operation immediately"
"\n\t\t\t instead of keep running until data is in
sync)",
.cmd = hmp_block_job_cancel,
+ .targets = "scsi",
},
SRST
@@ -133,6 +138,7 @@ ERST
.params = "device",
.help = "stop an active background block operation",
.cmd = hmp_block_job_complete,
+ .targets = "scsi",
},
SRST
@@ -147,6 +153,7 @@ ERST
.params = "device",
.help = "pause an active background block operation",
.cmd = hmp_block_job_pause,
+ .targets = "scsi",
},
SRST
@@ -160,6 +167,7 @@ ERST
.params = "device",
.help = "resume a paused background block operation",
.cmd = hmp_block_job_resume,
+ .targets = "scsi",
},
SRST
@@ -173,6 +181,7 @@ ERST
.params = "[-f] device",
.help = "eject a removable medium (use -f to force it)",
.cmd = hmp_eject,
+ .targets = "scsi",
},
SRST
@@ -186,6 +195,7 @@ ERST
.params = "device",
.help = "remove host block device",
.cmd = hmp_drive_del,
+ .targets = "scsi",
},
SRST
@@ -204,6 +214,7 @@ ERST
.params = "device filename [format [read-only-mode]]",
.help = "change a removable medium, optional format",
.cmd = hmp_change,
+ .targets = "scsi",
},
SRST
@@ -671,6 +682,7 @@ ERST
.help = "add device, like -device on the command line",
.cmd = hmp_device_add,
.command_completion = device_add_completion,
+ .targets = "scsi",
},
SRST
@@ -685,6 +697,7 @@ ERST
.help = "remove device",
.cmd = hmp_device_del,
.command_completion = device_del_completion,
+ .targets = "scsi",
},
SRST
@@ -1264,6 +1277,7 @@ ERST
"The -c flag requests QEMU to compress backup
data\n\t\t\t"
"(if the target format supports it).\n\t\t\t",
.cmd = hmp_drive_backup,
+ .targets = "scsi",
},
SRST
``drive_backup``
@@ -1280,6 +1294,7 @@ ERST
"[,readonly=on|off][,copy-on-read=on|off]",
.help = "add drive to PCI storage controller",
.cmd = hmp_drive_add,
+ .targets = "scsi",
},
SRST
@@ -1697,6 +1712,7 @@ ERST
.help = "add chardev",
.cmd = hmp_chardev_add,
.command_completion = chardev_add_completion,
+ .targets = "scsi",
},
SRST
@@ -1710,6 +1726,7 @@ ERST
.params = "id args",
.help = "change chardev",
.cmd = hmp_chardev_change,
+ .targets = "scsi",
},
SRST
@@ -1725,6 +1742,7 @@ ERST
.help = "remove chardev",
.cmd = hmp_chardev_remove,
.command_completion = chardev_remove_completion,
+ .targets = "scsi",
},
SRST
@@ -1739,6 +1757,7 @@ ERST
.help = "send a break on chardev",
.cmd = hmp_chardev_send_break,
.command_completion = chardev_remove_completion,
+ .targets = "scsi",
},
SRST
@@ -1810,6 +1829,7 @@ ERST
.params = "[subcommand]",
.help = "show various information about the system state",
.cmd = hmp_info_help,
+ .targets = "scsi",
.sub_table = hmp_info_cmds,
.flags = "p",
},
diff --git a/scripts/hxtool b/scripts/hxtool
old mode 100644
new mode 100755
index 7b1452f3cf..80c6845db1
--- a/scripts/hxtool
+++ b/scripts/hxtool
@@ -10,7 +10,39 @@ hxtoh()
SRST*|ERST*) flag=$(($flag^1))
;;
*)
- test $flag -eq 1 && printf "%s\n" "$str"
+ # Skip line that has ".targets" as it is for multi-process targets
based hmp
+ # commands generation.
+ echo $str | grep -q '.targets'
+ if [ $? -eq 0 ]; then
+ continue
+ else
+ test $flag -eq 1 && printf "%s\n" "$str"
+ fi
+ ;;
+ esac
+ done
+}
+
+hxtoh_tgt()
+{
+ section=""
+ flag=1
+ use_section=0
+ while read -r str; do
+ # Print section if it has ".targets" and the second argument passed to
the
+ # script, such as "scsi".
+ echo "$str" | grep -q -E ".targets.*$1"
+ if [ $? -eq 0 ]; then
+ use_section=1
+ continue
+ fi
+ case $str in
+ HXCOMM*)
+ ;;
+ SRST*|ERST*) flag=$(($flag^1)); test $use_section -eq 1 && printf
'%s' "$section"; section=""; use_section=0
+ ;;
+ *)
+ test $flag -eq 1 && section="${section} ${str} ${IFS}"
;;
esac
done
@@ -18,6 +50,7 @@ hxtoh()
case "$1" in
"-h") hxtoh ;;
+"-tgt") hxtoh_tgt $2 ;;
*) exit 1 ;;
esac
--
2.25.GIT
- Re: [PATCH v6 21/36] multi-process: PCI BAR read/write handling for proxy & remote endpoints, (continued)
- [PATCH v6 18/36] multi-process: Initialize Proxy Object's communication channel, elena . ufimtseva, 2020/04/06
- [PATCH v6 13/36] multi-process: setup PCI host bridge for remote device, elena . ufimtseva, 2020/04/06
- [PATCH v6 19/36] multi-process: Connect Proxy Object with device in the remote process, elena . ufimtseva, 2020/04/06
- [PATCH v6 22/36] multi-process: Synchronize remote memory, elena . ufimtseva, 2020/04/06
- [PATCH v6 26/36] multi-process: add parse_cmdline in remote process, elena . ufimtseva, 2020/04/06
- [PATCH v6 20/36] multi-process: Forward PCI config space acceses to the remote process, elena . ufimtseva, 2020/04/06
- [PATCH v6 25/36] multi-process: Introduce build flags to separate remote process code, elena . ufimtseva, 2020/04/06
- [PATCH v6 28/36] multi-process: send heartbeat messages to remote, elena . ufimtseva, 2020/04/06
- [PATCH v6 29/36] multi-process: handle heartbeat messages in remote process, elena . ufimtseva, 2020/04/06
- [PATCH v6 31/36] multi-process/mon: choose HMP commands based on target,
elena . ufimtseva <=
- [PATCH v6 23/36] multi-process: create IOHUB object to handle irq, elena . ufimtseva, 2020/04/06
- [PATCH v6 33/36] multi-process/mon: enable QMP module support in the remote process, elena . ufimtseva, 2020/04/06
- [PATCH v6 36/36] multi-process: add configure and usage information, elena . ufimtseva, 2020/04/06
- [PATCH v6 32/36] multi-process/mon: stub functions to enable QMP module for remote process, elena . ufimtseva, 2020/04/06
- [PATCH v6 35/36] multi-process: add the concept description to docs/devel/qemu-multiprocess, elena . ufimtseva, 2020/04/06
- [PATCH v6 02/36] multi-process: Refactor machine_init and exit notifiers, elena . ufimtseva, 2020/04/06
- [PATCH v6 03/36] command-line: refractor parser code, elena . ufimtseva, 2020/04/06
- [PATCH v6 06/36] monitor: destaticize HMP commands, elena . ufimtseva, 2020/04/06
- [PATCH v6 09/36] multi-process: Add config option for multi-process QEMU, elena . ufimtseva, 2020/04/06